"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.surely = exports.any = void 0;
const _1 = require(".");
const types_1 = require("../types");
function any(...parsers) {
    return (ctx) => {
        const expected = [];
        for (const parser of parsers) {
            const res = parser(ctx);
            if ((0, types_1.isFailure)(res)) {
                if (res.history.includes('surely')) {
                    console.log('shot');
                    return (0, types_1.failure)(res.ctx, res.expected, res.history.filter(h => h !== 'surely'));
                }
                expected.push(res);
            }
            else
                return res;
        }
        const longest = expected.reduce((a, b) => a.history.length > b.history.length ? a : b);
        return (0, types_1.failure)(longest.ctx, longest.expected, ['any', ...longest.history]);
    };
}
exports.any = any;
function surely(parser) {
    return (0, _1.expect)(parser, 'surely');
}
exports.surely = surely;
