"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.realP = exports.real = exports.intP = exports.int = exports.boolP = exports.bool = exports.wspaces = exports.spacesPlus = exports.spaces = void 0;
const map_1 = require("./map");
const opt_1 = require("./opt");
const regex_1 = require("./regex");
const seq_1 = require("./seq");
const str_1 = require("./str");
const utilities_1 = require("./utilities");
/** Parses 0 or more spaces
 */
exports.spaces = (0, regex_1.regex)(/ */, 'spaces');
/** Parses 1 or more spaces
 */
exports.spacesPlus = (0, regex_1.regex)(/ +/, 'spaces');
/** Parses 0 or more whitespace characters
 */
exports.wspaces = (0, opt_1.opt)((0, regex_1.regex)(/(?:\s|\t|\n|\r)+/, 'whitespace characters'));
/** Parses a boolean (true or false) and returns a string
 */
exports.bool = (0, regex_1.regex)(/true|false/, 'boolean');
/** Parses a boolean (true or false) and returns a boolean
 */
exports.boolP = (0, map_1.map)(exports.bool, val => val === 'true');
/** Parses an integer and returns a string
 */
exports.int = (0, regex_1.regex)(/\d+/, 'integer');
/** Parses an integer and returns a number
 */
exports.intP = (0, map_1.map)(exports.int, seq => parseInt(seq, 10));
/** Parses a standard real number (X.X) and returns a string
 */
exports.real = (0, utilities_1.expect)((0, map_1.map)((0, seq_1.seq)(exports.int, (0, str_1.str)('.'), exports.int), ([intPart, , decimalPart]) => `${intPart}.${decimalPart}`), 'real');
/** Parses a standard real number (X.X) and returns a number
 */
exports.realP = (0, map_1.map)(exports.real, (seq) => parseFloat(seq));
